using FL.Database;
using System;
using System.IO;
using System.Reflection;
using UnityEditor;
using UnityEngine;
using XGame.Framework.Serialization;

namespace FL.Editor.Tests
{
    public static class TestDatabase
    {
        [UnityEditor.MenuItem("Test/TestDatabase/WriteTables")]
        public static void WriteTables()
        {
            var length = 10;
            var tables = new SimpleTable[length];
            for (int i = 0; i < length; i++)
            {
                var table = new SimpleTable()
                {
                    id = i,
                    name = typeof(SimpleTable).Name + i,
                    simpleType = (SimpleType)(i % 2)
                };
                tables[i] = table;
            }
            var tableRepo = new SimpleTableRepo();

            var fileInfo = typeof(SimpleTableRepo).GetField("_tables", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.IgnoreCase);
            if (fileInfo == null)
            {
                Debug.LogError($"ûҵֶ: _tables");
                return;
            }
            fileInfo.SetValue(tableRepo, tables);
            var writer = new Writer();
            (tableRepo as ISerializable).Serialize(writer);
            var bytes = writer.Finish();
            var path = $"Assets/Res/Dynamic/Tables/SimpleTable.bytes";
            File.WriteAllBytes(path, bytes);

            var reader = new Reader(bytes);
            var result = Activator.CreateInstance<SimpleTableRepo>() as ISerializable;
            result.Deserialize(reader);
            AssetDatabase.Refresh();
            Debug.Log($"WriteTables End.");
        }
    }
}

