﻿using FairyGUI;
using XGame.Framework.UI.View;

namespace XGame.Framework.FGUI
{
    /// <summary>
    /// FGUI相关的操作都在IUIViewModel的实现类里
    /// </summary>
    public abstract class UIViewModelFGUI : IUIViewModel
    {
        protected GComponent _panel;
        public UIViewModelFGUI(GComponent panel)
        {
            _panel = panel;
            BindComponents(panel);
            OnInited();
        }
        /// <summary>
        /// 结束ui的所有tween
        /// </summary>
        public void KillTweens(bool complete = false)
        {
            GTween.Kill(_panel, complete);
        }
        protected abstract void BindComponents(GComponent panel);
        protected abstract void OnInited();
    }
}